<?php
if (!defined ('TYPO3_MODE')) 	die ('Access denied.');

$TCA["tx_worldcup_teams"] = Array (
	"ctrl" => $TCA["tx_worldcup_teams"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "name,shortcut"
	),
	"feInterface" => $TCA["tx_worldcup_teams"]["feInterface"],
	"columns" => Array (
		"name" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_teams.name",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"max" => "255",	
				"eval" => "required",
			)
		),
		"shortcut" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_teams.shortcut",		
			"config" => Array (
				"type" => "input",	
				"size" => "5",	
				"max" => "3",	
				"eval" => "required",
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "name;;;;1-1-1, shortcut")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);



$TCA["tx_worldcup_bets"] = Array (
	"ctrl" => $TCA["tx_worldcup_bets"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "game,goals_team1,goals_team2,fe_user_id"
	),
	"feInterface" => $TCA["tx_worldcup_bets"]["feInterface"],
	"columns" => Array (
		"game" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_bets.game",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_worldcup_games",	
				"foreign_table_where" => "AND tx_worldcup_games.pid=###CURRENT_PID### ORDER BY tx_worldcup_games.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"goals_team1" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_bets.goals_team1",		
			"config" => Array (
				"type" => "input",	
				"size" => "5",	
				"max" => "2",	
				"checkbox" => "",	
				"eval" => "required,trim,nospace",
			)
		),
		"goals_team2" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_bets.goals_team2",		
			"config" => Array (
				"type" => "input",	
				"size" => "5",	
				"max" => "2",	
				"checkbox" => "",	
				"eval" => "required,trim,nospace",
			)
		),
		"fe_user_id" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_bets.fe_user_id",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "fe_users",	
				"foreign_table_where" => "ORDER BY fe_users.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "game;;;;1-1-1, goals_team1, goals_team2, fe_user_id")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);



$TCA["tx_worldcup_games"] = Array (
	"ctrl" => $TCA["tx_worldcup_games"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "playtime,team1,team2,goals_team1,goals_team2,place,finals"
	),
	"feInterface" => $TCA["tx_worldcup_games"]["feInterface"],
	"columns" => Array (
		"playtime" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.playtime",		
			"config" => Array (
				"type" => "input",
				"size" => "12",
				"max" => "20",
				"eval" => "datetime",
				"checkbox" => "0",
				"default" => "0"
			)
		),
		"team1" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.team1",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_worldcup_teams",	
				"foreign_table_where" => "ORDER BY tx_worldcup_teams.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"team2" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.team2",		
			"config" => Array (
				"type" => "select",	
				"foreign_table" => "tx_worldcup_teams",	
				"foreign_table_where" => "ORDER BY tx_worldcup_teams.uid",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"goals_team1" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.goals_team1",		
			"config" => Array (
				"type" => "input",	
				"size" => "5",	
				"max" => "2",	
				"checkbox" => "",	
				"eval" => "trim,nospace",
			)
		),
		"goals_team2" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.goals_team2",		
			"config" => Array (
				"type" => "input",	
				"size" => "5",	
				"max" => "2",	
				"checkbox" => "",	
				"eval" => "trim,nospace",
			)
		),
		"place" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.place",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"finals" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals",		
			"config" => Array (
				"type" => "radio",
				"items" => Array (
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.0", "A"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.1", "B"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.2", "C"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.3", "D"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.4", "E"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.5", "F"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.6", "G"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.7", "H"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.8", "16"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.9", "8"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.10", "4"),
					Array("LLL:EXT:worldcup/locallang_db.xml:tx_worldcup_games.finals.I.11", "2"),
				),
			)
		),
	),
	"types" => Array (
		"0" => Array("showitem" => "playtime;;;;1-1-1, team1, team2, goals_team1, goals_team2, place, finals")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "")
	)
);
?>